#**********************************************************************
#     model2d.f: n2packȤä2ȯ򤯥ץ
#
#                                                    96/10/27 K.Ishioka
#**********************************************************************
# 05/07/20 test_n2pack.rb FortranץRubyˤ R.Mizuta
#----------------------------------------------------------------------
require "narray"
require "numru/ispack"
require "numru/dcl"
include NumRu
include NMath

# ѥ᥿ 

      jm=128; im=128      #ʻ(jm: y, im: x)
      lm=63; km=63        #ȿ(aliasingȤäƤʤ)
#      lm=42; km=42        #ȿ(aliasingȤ)
      n=(2*lm+1)*(2*km+1) #ڥȥѿ礭

      nstep=100                 #ȯŸ륹ƥå׿
      h=1.0                     #եåɽΤλֳִ
      m=3                       #Runge-KuttaǤΥƥåʬ      

      nv=5                      #ⳬǴΥץ饷γ
      dnu=1e-17                 #ⳬǴ
      deltat=h/m                #runge-kuttaλֹ

# 

# Ϳ줿, SBGDZNǻȤDL(Ǵˤ븺̤Ϳ)
# ꤹ. ʤ, SBGDZNRunge-KuttaǸƤӽФ뤬, κ,
# DT=DELTAT/2ǸƤӽФ뤫, θ, DLϰʲΤ
# Ǥ.

      l = (NArray.float(lm*2+1).indgen! - lm).newdim!(1)
      k = (NArray.float(km*2+1).indgen! - km).newdim!(0)
      DL = exp(-dnu*deltat/2*(1.0*(k*k+l*l))**nv)

# N2PACKν

      n2 = N2PACK.new(lm,km,jm,im)

# եåν

      DCL::swiset('iwidth',  400)
      DCL::swiset('iheight', 400)
#      DCL::swlset('lwait',false)
#      DCL::swlset('lalt',true)
      DCL::sglset('lcorner',false)

      DCL::gropn(1)
      DCL::uzpset('inner',-1)
      DCL::slrat(1.0,1.0)
      DCL::glpset('lmiss',true)
      DCL::sgpset('lcntl',true)
      DCL::slrat(1.0,1.0)
      DCL::udgcla(0.0,1.0,0.1)

      ipat0=25
      dlev=0.05
      nlev=20
      idlev=3

      DCL::uestlv(999.0,0.0,ipat0*1000+999)
      for i in 1..nlev-1
        ipat=(ipat0+i*idlev)*1000+999
        tlev1=(i-1)*dlev
        tlev2=i*dlev
        DCL::uestlv(tlev1,tlev2,ipat)
      end
      ipat=(ipat0+nlev*idlev)*1000+999
      DCL::uestlv(tlev2,999.0,ipat)

#     ٤Υڥȥ뷸(Z)ν

# Ǥ, 2ĤΥ󷿤α뱲ʬۤʻͿ, 
# N2G2SAȤäƥڥȥ뷸Ѵ, Zνͤ
# Ƥ

      x1=0.4
      y1=0.4
      x2=0.6
      y2=0.6
      sigma=0.05

      y = ((NArray.float(jm).indgen!)/jm).newdim!(1)
      x = ((NArray.float(im).indgen!)/im).newdim!(0)

      g0 = exp(-((x-x1)**2+(y-y1)**2)/(2*sigma**2)) + 
           exp(-((x-x2)**2+(y-y2)**2)/(2*sigma**2))

      z = n2.g2sa(g0)

      z[lm,km]=0.0                #٤ʿѤ0ǤʤФʤʤ

    def sbgrph(t,z,n2)

      ctime = sprintf('%6.1f',t)

#      shape = z.shape
      g = n2.s2ga(z)
#      z.reshape!(*shape) # zreshapeƤޤΤǸ᤹

      im = n2.im
      jm = n2.jm
      rg = NArray.sfloat(im+1,jm+1)        #եå˻Ȥ
      rg[0..im-1,0..jm-1] = g.transpose(1,0)

      rg[im,true] = rg[0,true]
      rg[true,jm] = rg[true,0]

      DCL::grfrm
      DCL::sgsvpt(0.15,0.9,0.15,0.9)
      DCL::sgswnd(0.0,1.0,0.0,1.0)
      DCL::sgstrn(1)
      DCL::sgstrf

      DCL::uetone(rg)
#      DCL::udcntr(rg)
      DCL::usdaxs
      DCL::uxsttl('t','t='+ctime,1.0)
#      DCL::grfrm

    end


#----------------------------------------------------------------------
#     (T)ӱ٤Υڥȥ뷸(Z)ϤȤ, Υ
#     ȥ뷸(DZ)륵֥롼(Runge-KuttaǻȤ)
#----------------------------------------------------------------------
    def sbgdzn(z,n2)

#      shape = z.shape
      dz = n2.ajbs(z)
#      z.reshape!(*shape) # zreshapeƤޤΤǸ᤹
#      return dz

    end
#----------------------------------------------------------------------
#     (T)ӻֹ(DT)ϤȤ, (Ǵ)ˤZ
#     TT+DTˤȯŸ򤯥֥롼(Runge-KuttaǻȤ)
#----------------------------------------------------------------------
    def sbgdzl(z)

      z = DL * z

    end


alias subl sbgdzl
alias subn sbgdzn

def integral(dt,t,z,n2) # 󥲥åʬ

  dt = dt.to_f

  dz1 = subn(z,n2)
#  p z,dz1
  dz2 = z + dz1*dt/2
  dz3 = z + dz1*dt/6

  z = subl(z)
  dz2 = subl(dz2)
  dz3 = subl(dz3)
  dz1 = subn(dz2,n2)

  dz2 = z + dz1*dt/2
  dz3 = dz3 + dz1*dt/3

  dz1 = subn(dz2,n2)

  dz2 = z + dz1*dt
  dz3 = dz3 + dz1*dt/3

  dz2 = subl(dz2)
  dz3 = subl(dz3)
  dz1 = subn(dz2,n2)

  t = t + dt
  z = dz3 + dz1*dt/6

  return t,z

end

# ȯŸӥեåɽ

      t=0                       #tϻɽѿ
      sbgrph(t,z,n2)

      for istep in 1..nstep
        m.times do
          t,z = integral(deltat,t,z,n2)
        end
        sbgrph(t,z,n2)
      end

# λ

      DCL::grcls

